//
//  MZSecurityManager_Tests.m
//  MezzKit
//
//  Created by miguel on 27/11/14.
//  Copyright (c) 2014 Oblong Industries. All rights reserved.
//

#import <XCTest/XCTest.h>
#import "MezzKit.h"
#import "OCMockObject.h"
#import "OCMockRecorder.h"
#import "OCMConstraint.h"
#import "OCMArg.h"
#import "NSNotificationCenter+OCMAdditions.h"

#define DHC_MOCK_VALUE(variable) [NSValue value : &variable withObjCType : @encode(__typeof__(variable))]

@interface MZSecurityManager_Tests : XCTestCase
{
  MZSecurityManager *securityManager;
}
@end

@implementation MZSecurityManager_Tests

- (void)setUp
{
  [super setUp];
  securityManager = [MZSecurityManager new];
}

- (void)tearDown
{
  [super tearDown];
}

#pragma mark - MZSecurityManager Tests

- (void)testAuthenticationSpaceInvalidCertificate
{
  SecTrustRef trust = [self trustChainForInvalidTestServer];

  id mockProtectionSpace = [OCMockObject mockForClass:[NSURLProtectionSpace class]];
  [[[mockProtectionSpace stub] andReturnValue:DHC_MOCK_VALUE(trust)] serverTrust];
  [[[mockProtectionSpace stub] andReturn:@"invalid-test-server"] host];

  XCTAssertFalse([securityManager authenticateAgainstProtectionSpace:mockProtectionSpace], @"Authentication should fail");
}

- (void)testAuthenticationSpaceValidCertificate
{
  SecTrustRef trust = [self trustChainForValidTestServer];

  id mockProtectionSpace = [OCMockObject mockForClass:[NSURLProtectionSpace class]];
  [[[mockProtectionSpace stub] andReturnValue:DHC_MOCK_VALUE(trust)] serverTrust];
  [[[mockProtectionSpace stub] andReturn:@"mezzdelpi"] host];

  XCTAssertTrue ([securityManager authenticateAgainstProtectionSpace:mockProtectionSpace], @"Authentication should be OK");
}

- (void)testValidChallenge
{
  SecTrustRef trust = [self trustChainForValidTestServer];

  id mockProtectionSpace = [OCMockObject mockForClass:[NSURLProtectionSpace class]];
  [[[mockProtectionSpace stub] andReturnValue:DHC_MOCK_VALUE(trust)] serverTrust];
  [[[mockProtectionSpace stub] andReturn:@"mezzdelpi"] host];

  id mockChallenge = [OCMockObject mockForClass:[NSURLAuthenticationChallenge class]];
  id mockSender = [OCMockObject mockForClass:[NSURLConnection class]];

  int zero = 0;
  [[[mockChallenge stub] andReturnValue:DHC_MOCK_VALUE(zero)] previousFailureCount];
  [[[mockChallenge stub] andReturn:mockSender] sender];
  [[[mockChallenge stub] andReturn:mockProtectionSpace] protectionSpace];
  [[[mockChallenge stub] andReturn:nil] proposedCredential];
  [[mockSender expect] useCredential:[OCMArg any] forAuthenticationChallenge:mockChallenge];

  XCTAssertNotNil([securityManager credentialsFromAuthenticationChallenge:mockChallenge], @"Authentication Challenge should produce a valid NSURLCredential");
}


- (void)testInvalidChallenge
{
  SecTrustRef trust = [self trustChainForInvalidTestServer];

  id mockProtectionSpace = [OCMockObject mockForClass:[NSURLProtectionSpace class]];
  [[[mockProtectionSpace stub] andReturnValue:DHC_MOCK_VALUE(trust)] serverTrust];
  [[[mockProtectionSpace stub] andReturn:@"invalid-test-server"] host];

  id mockChallenge = [OCMockObject mockForClass:[NSURLAuthenticationChallenge class]];
  id mockSender = [OCMockObject mockForClass:[NSURLConnection class]];

  int zero = 0;
  [[[mockChallenge stub] andReturnValue:DHC_MOCK_VALUE(zero)] previousFailureCount];
  [[[mockChallenge stub] andReturn:mockSender] sender];
  [[[mockChallenge stub] andReturn:mockProtectionSpace] protectionSpace];
  [[[mockChallenge stub] andReturn:nil] proposedCredential];
  [[mockSender expect] useCredential:[OCMArg any] forAuthenticationChallenge:mockChallenge];

  XCTAssertNil([securityManager credentialsFromAuthenticationChallenge:mockChallenge], @"Authentication Challenge should not produce any NSURLCredential");
}


// Returns a SecTrustRef based on a debug server certificate that has been validated with the current Oblong Root CA.
// Use a server certificate generated by a Mezzanine and saved at /etc/oblong/server-certificate-chain.pem
// NOTE: The current valid-test-server-certificate-chain.pem certificate will expire Dec/6/2019
- (SecTrustRef) trustChainForValidTestServer
{
  NSBundle *bundle = [NSBundle bundleForClass:[MZSecurityManager_Tests class]];
  NSString *pemPath = [bundle pathForResource:@"valid-test-server-certificate-chain" ofType:@"pem"];

  CFMutableArrayRef certsArray = [securityManager loadCertificatesFromFilePath:pemPath];
  XCTAssertTrue([(NSMutableArray *)CFBridgingRelease(certsArray) count] == 3, @"There should be one valid certificate in valid-test-server-certificate-chain.pem");

  SecPolicyRef policy = SecPolicyCreateSSL(YES, (__bridge CFStringRef)@"mezzdelpi");
  SecTrustRef trust = NULL;
  SecTrustCreateWithCertificates(certsArray, policy, &trust);
  CFRelease(policy);

  return trust;
}

// Returns a SecTrustRef based on a dummy certificate and therefore
// cannot be validated with the current Oblong Root CA.
- (SecTrustRef) trustChainForInvalidTestServer
{
  NSBundle *bundle = [NSBundle bundleForClass:[MZSecurityManager_Tests class]];
  NSString *pemPath = [bundle pathForResource:@"dummycert" ofType:@"pem"];

  CFMutableArrayRef certsArray = [securityManager loadCertificatesFromFilePath:pemPath];
  XCTAssertTrue([(NSMutableArray *)CFBridgingRelease(certsArray) count] == 1, @"There should be one valid certificate in dummycert.pem");


  SecPolicyRef policy = SecPolicyCreateBasicX509();
  SecTrustRef trust = NULL;
  SecTrustCreateWithCertificates(certsArray, policy, &trust);
  CFRelease(policy);
  
  return trust;
}


@end
